# The One Billion Row Challenge

This is my attempt at Gunnar Morling's [One Billion Row Challenge](https://www.morling.dev/blog/one-billion-row-challenge/). You can find a detailed description of this project on [my blog](https://www.drywa.me/one-billion-rows/).

## Info

Build Platform: `Windows 11 Home 64-bit - 23H2 - 22631.3880`

Compiler: `Microsoft (R) C/C++ Optimizing Compiler Version 19.38.33135 for x64`


## How to build

Make sure you have `cl.exe` installed and it can be used from the terminal (run `cl /help` to test).
To obtain the latest version of the MSVC compiler check out [PortableBuildTools](https://github.com/Data-Oriented-House/PortableBuildTools).

Go to the main directory of the 1billion source code and run `build` to execute the `build.bat` script. This will build the product in debug mode. The resulting build artefacts can be found under `build\debug`. To build the product in release mode run `build release` instead. The resulting build artefacts can be found under `build\release`.

To run the built executable right after the build step use `build run` (`build debug run` or `build release run` if you want to target specific versions. The default is `debug`).

To run the built executable with the RAD Debugger attached use `build rundbg` (`build debug rundbg` or `build release rundbg` if you want to target specific versions. The default is `debug`).

To create an executable that is ready for distribution use `build release publish`. The resulting build artefacts can be found under `build\publish`.


## How to use

The first thing to do is run the `1billion` executable with the `generate` command (`1billion generate`). This will create a roughly *13 GiB* `measurements.txt` file in the working directory of the executable, which contains 1 billion rows of weather station data.

To then run the current best implementation of the challenge execute `1billion run`. This will now read and parse the `measurements.txt` file and output the min, mean, and max for each weather station to the terminal, together with a runtime breakdown.

To run a specific implementation of the challenge execute the run command with an additional index, for example `1billion run 2` to run the *3rd* attempt. At the moment the run command accepts the following indices:

* `0` - The very first baseline implementation.

To run benchmarks for all implementations available execute `1billion benchmark`. This will take a while since it will run each implementation multiple times and print out a breakdown of each implementation with various statistics. At the moment there is no benchmark available as only the baseline implementation exists.


## License

The entire source code, unless stated otherwise in individual files, is `Public Domain (www.unlicense.org)`


## Third party libraries

The following third party libraries are being used in this project:

* `stb_sprintf - v1.10`: Licensed under `Public Domain (www.unlicense.org)`
