typedef enum ATTEMPT_ENUM attempt_enum;
enum ATTEMPT_ENUM {
    ATTEMPT_01 = 0,

    ATTEMPT_COUNT,
    ATTEMPT_FASTEST = ATTEMPT_01,
};

typedef enum ATTEMPT_TYPE_ENUM attempt_type;
enum ATTEMPT_TYPE_ENUM {
    ATTEMPT_TYPE_RUN = 0,
    ATTEMPT_TYPE_BENCHMARK = 1,
};

#include "attempt01.c"

string GetAttemptName(attempt_enum attempt) {
    switch (attempt) {
        case ATTEMPT_01: return StringLiteral("Attempt 01");
        default: return StringLiteral("INVALID");
    }
}

void RunAttempt(attempt_enum attempt, attempt_type type, memory_arena *arena, program_times *times) {
    switch (attempt) {
        case ATTEMPT_01: RunAttempt01(arena, times, type); break;
        default: WriteError(StringLiteral("Invalid attempt index\n")); break;
    }
}
