typedef struct PROGRAM_TIMES program_times;
struct PROGRAM_TIMES {
    profiler_zone reading;
    profiler_zone output;
    profiler_zone overall;
};

static u64 g_cpu_frequency_in_ticks = 0;

static const string g_measurements_filename = StringLiteralConst("measurements.txt");

void InitProgramTimings() {
    g_cpu_frequency_in_ticks = ReadCPUTimerFrequency(100);
    WarmupProfiler();
}

void PrintProfileZone(memory_arena *arena, string name, profiler_zone zone) {
    u64 ticks = zone.ticks_end - zone.ticks_start;
    f64 seconds = (f64)ticks / (f64)g_cpu_frequency_in_ticks;
    f64 milliseconds = seconds * 1000.0;

    string output = StringFormat(arena, "%.*s - %_$.5llu ticks - %fs - %fms\n", StringToFormatArgs(name), ticks, seconds, milliseconds);
    WriteMessage(output);
}

void PrintTimes(memory_arena *arena, program_times *times) {
    PrintProfileZone(arena, StringLiteral("Reading"), times->reading);
    PrintProfileZone(arena, StringLiteral("Output"), times->output);
    PrintProfileZone(arena, StringLiteral("Overall"), times->overall);
}
