u32 RunProgram(memory_arena *arena, u32 index) {
    program_times times = {0};

    if (index >= ATTEMPT_COUNT) {
        string error = StringFormat(arena, "Invalid Attempt index %lu - Valid attempts are from 0 to %lu\n", index, ATTEMPT_COUNT - 1);
        WriteError(error);
        return EXIT_CODE_INVALID_ATTEMPT;
    }

    string message = StringFormat(arena, "Running Attempt index %lu...\n", index);
    WriteMessage(message);

    InitProgramTimings();
    RunAttempt(index, ATTEMPT_TYPE_RUN, arena, &times);
    
    PrintTimes(arena, &times);
    return EXIT_CODE_SUCCESS;
}
